#include "StdAfx.h"
#include "NListCtrlEx.h"

INListCtrlExCallBack::~INListCtrlExCallBack()
{

}

CNListCtrlEx::CNListCtrlEx(void)
{
	m_bMouseTrack = TRUE;
	//m_bEnableHove = false;
	//m_nImageCol = -1;
    //m_bInited = FALSE;
	//m_bshowtip = false;
    m_nItem = -1;
    m_nSubItem = -1;
    m_bEnableItemTips = TRUE;
    //m_pOldToolTips = NULL;
    m_pCallBack = NULL;
}

CNListCtrlEx::~CNListCtrlEx(void)
{

}

BEGIN_MESSAGE_MAP(CNListCtrlEx, CNListCtrl)
	ON_WM_MOUSEHOVER()
	ON_WM_MOUSEMOVE()
	ON_WM_MOUSELEAVE()
    //ON_WM_CREATE()
    //ON_WM_DESTROY()
END_MESSAGE_MAP()

void CNListCtrlEx::_ShowTooltip(HWND hwnd, CString strToolTip)
{
    BOOL bRet = FALSE;
    //GetToolTips()->AddTool(this, strToolTip);
    //API_VERIFY(m_ToolTips.AddTool(this, strToolTip));
    ShowTooltip(hwnd, strToolTip);
}
void CNListCtrlEx::_HideTooltip(HWND hWnd)
{
    //GetToolTips()->DelTool(this);
    //m_ToolTips.DelTool(this);
    HideTooltip(hWnd);
}

void CNListCtrlEx::_ReCalcItemToolTip(UINT nFlags, CPoint point)
{
    //CToolTipCtrl* pToolTipCtrl = GetToolTips();
    CString strToolTip;  
    LVHITTESTINFO lvhti = { 0 }; 

    lvhti.pt = point;      
    SubItemHitTest(&lvhti);  
    if((lvhti.iItem != m_nItem) || (lvhti.iSubItem != m_nSubItem))  
    {  
        m_nItem = lvhti.iItem;  
        m_nSubItem = lvhti.iSubItem;  

        if((m_nItem != -1) && (m_nSubItem != -1))  
        {  
            if (!m_pCallBack || !m_pCallBack->OnGetItemToolTip(this, m_nItem, m_nSubItem, strToolTip))
            {
                strToolTip = GetItemText(m_nItem ,m_nSubItem);
            }
            if (strToolTip.IsEmpty())
            {
                //FTLTRACE(TEXT("HideTooltip(%d,%d) strToolTip is Empty\n"), m_nItem, m_nSubItem);
                _HideTooltip(m_hWnd);
            }
            else
            {
                //FTLTRACE(TEXT("ShowTooltip(%d,%d) strToolTip = %s\n"), m_nItem, m_nSubItem, strToolTip);
                _HideTooltip(m_hWnd);
                _ShowTooltip(m_hWnd, strToolTip);
                //pToolTipCtrl->AddTool(this, str);
                //pToolTipCtrl->Pop();
            }
        }  
        else  
        {  
            //FTLTRACE(TEXT("HideTooltip(%d,%d) nItem or nSubItem is -1\n"), m_nItem, m_nSubItem);
            _HideTooltip(m_hWnd);
            //pToolTipCtrl->DelTool(this);
        }  
    }  
}

void CNListCtrlEx::OnMouseMove(UINT nFlags, CPoint point)
{
    BOOL bRet = FALSE;

	LVHITTESTINFO lvhti = { 0 }; 

	lvhti.pt = point;      
	SubItemHitTest(&lvhti);  
	if(lvhti.iSubItem == 0)  
	{
		::SetCursor(LoadCursor(NULL,IDC_HAND));
	}

    if(m_bEnableItemTips)  
    {  
        if (m_bMouseTrack)    
        {
            TRACKMOUSEEVENT csTME = {0};
            csTME.cbSize = sizeof(csTME);
            csTME.dwFlags = TME_LEAVE|TME_HOVER;
            csTME.hwndTrack = m_hWnd;
            csTME.dwHoverTime = 10; 
            API_VERIFY(::_TrackMouseEvent(&csTME));
            m_bMouseTrack = FALSE;  
        }
        //FTLTRACE(TEXT("CNListCtrlEx::OnMouseMove, point=%d,%d\n"), point.x, point.y);
        _ReCalcItemToolTip(nFlags, point);
    }  

    CListCtrl::OnMouseMove(nFlags, point);  
}

void CNListCtrlEx::OnMouseHover(UINT nFlags, CPoint point)
{
	if (m_bEnableItemTips) // m_bEnableHove)
	{
        //FTLTRACE(TEXT("CNListCtrlEx::OnMouseHover, point=%d,%d\n"), point.x, point.y);
        _ReCalcItemToolTip(nFlags, point);
	}
	 __super::OnMouseHover(nFlags,point);
}

void CNListCtrlEx::OnMouseLeave()
{
	if (m_bEnableItemTips)
	{ 
        //FTLTRACE(TEXT("CNListCtrlEx::OnMouseLeave\n"));
		m_bMouseTrack = TRUE;
        _HideTooltip(m_hWnd);
		//HideWorkStatusTooltip();
	}
   __super::OnMouseLeave();
}

//
//void CNListCtrlEx::ShowWorkStatusTooltip( int nIndex )
//{
//	CString strWorkStatus; 
//
//	::SendMessage(GetParent()->m_hWnd,UM_CHAT_GET_STATUS,(WPARAM)nIndex,(LPARAM)&strWorkStatus);
//	if (strWorkStatus.IsEmpty())
//		return;
//
//	if(!m_bshowtip)
//		m_bshowtip = ShowTooltip( m_hWnd , strWorkStatus);
//}
//
